#!/usr/bin/env python


from pathlib import Path
import wx
from nardascripting.base.usrscriptbase import *
from nardascripting.base.signalsharkdev import *
import nardascripting.base.toolbox as TB


class Example04(UsrScriptBase):
    """User script class"""

    def __init__(self, main_gui, dev=SignalSharkDev()):
        """Initialization. Please leave this line unchanged"""
        super().__init__(main_gui, dev, __file__)

        # Script settings.
        # -------------------------------------------------------------------------------
        # Please adapt the following lines of code according to your script.
        self._tab_name = "Examples"
        self._scr_title = "Example 04 - Controlling SignalShark and querying Values"
        self._scr_description = "Shows how to connect to SignalShark, " \
                                "get some SCPI based values and load and save settings."
        # self._icon_path = self.script_path.joinpath("NardaScriptLauncher_example01.png")
        self._list_prio = 3
        self._nsl_executed_behavior = NSL_Executed_Behaviors.SHOW_NSL

        # Add class variables if needed
        # -------------------------------------------------------------------------------
        # self.my_variable = None

    def _run_script(self, args):
        """
        Script main function
        This method is called when a user clicks on the corresponding script button.
        """
        # Add your code here:

        # 'self.signalshark': Provides access to the SignalShark device
        self.signalshark.connect()
        idn = self.signalshark.device_info

        # 'self.signalshark.scpi': wraps SCPI commands
        self.signalshark.scpi.spectrum.set_measurement_time(0.1)

        self.signalshark.disconnect()

        # 'self.config': Load and store config parameters
        my_value = self.config.get("my_value", 10)
        new_value = my_value + 1
        self.config['my_value'] = new_value

        # e.g. show a message box:
        self.MessageBoxModal("This is a wxPython messagebox.",
                             "MyUserScript", wx.OK | wx.ICON_INFORMATION)

